/*
 * Copyright (c) 2014-2016 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 *					Anthony Mallet on Tue Feb 18 2014
 */
#ifndef H_OPTITRACK_CODELS
#define H_OPTITRACK_CODELS

#include <stdio.h>

#include "natnet.h"

struct optitrack_server_s {
  natnet_context_s natnet;
};

struct optitrack_bodies_info_s {
  const struct natnet_descr *descr;
};

struct optitrack_log_s {
  FILE *f;
};


genom_event	opti_create_ports(const struct natnet_descr *descr,
                        const optitrack_ids_pubdata_s *pubdata,
                        const optitrack_bodies *bodies,
                        const optitrack_markers *markers,
                        genom_context self);
genom_event	opti_update_ports(const struct natnet_frame *f,
                        optitrack_server_s *server,
                        optitrack_bodies_info_s *binfo,
                        const optitrack_ids_pubdata_s *pubdata,
                        const optitrack_ids_noise_s *noise,
                        const optitrack_bodies *bodies,
                        const optitrack_markers *markers,
                        FILE *log, genom_context self);

#endif /* H_OPTITRACK_CODELS */
